var Inicio_Controller = function(templateManager, LibUtilities, ApplicationContext, localStorageEngine, requestDataSourceEngine, ScreenService, restEngine, metaDataFactory, General){

    var self = this;
    var modalConfirmaRecebimentoAF = function () {
		var widgetConfirmaRecebAF = metaDataFactory.widgetFactory({
		    "id": "0",
			"name": "recebimentoAF",
			"label": "Confirmação de Recebimento",
			"template": "widget/grid.html",
			"isVisible": true,
			"showCheckbox": true,
			"showAsModal": true,
			"floatingControl": {
                "csvAction": false,
                "pdfAction": false,
                "xlsAction": false,
                "refreshAction": false,
                "customizationAction": {
                    "filter": false,
                    "layout": false,
                    "view": false
                }
            },
			"dataSource": {
                "name": "product#/crud/confirmaRecebimentoAF",
                "rest": true,
                "lazyLoad": true
            },
            "dataSourceFilter": [
                {
                    "name": "P_CDFILDEST",
                    "value": "@getLocalVar('CDFILIAL')@",
                    "operator": "="
                },
                {
                    "name": "P_NRORG",
                    "value": "@getLocalVar('NRORG')@",
                    "operator": "="
                }
            ],
			"fields": [
			    {
                    "name": "NRAUTOFORN",
                    "label": "AF",
                    "isVisible": true,
                    "readOnly": false,
                    "showOnForm": true,
                    "showOnView": false,
                    "showOnList": true,
                    "class": 3,
                    "template": "field/text-edit.html",
                    "events": [],
                    "disableOrdering": true
                },
                {
                    "name": "NRINSJURFORN",
                    "label": "Inscrição",
                    "isVisible": true,
                    "readOnly": false,
                    "showOnForm": true,
                    "showOnView": false,
                    "showOnList": true,
                    "class": 3,
                    "template": "field/text-edit.html",
                    "events": [],
                    "disableOrdering": true
                },
                {
                    "name": "NMFANTFORN",
                    "label": "Nome Fantasia",
                    "isVisible": true,
                    "readOnly": false,
                    "showOnForm": true,
                    "showOnView": false,
                    "showOnList": true,
                    "class": 3,
                    "template": "field/text-edit.html",
                    "events": [],
                    "disableOrdering": true
                },
                {
                    "name": "DTPROGENTAF",
                    "label": "Dt Entrega AF",
                    "isVisible": true,
                    "readOnly": false,
                    "showOnForm": true,
                    "showOnView": false,
                    "showOnList": true,
                    "class": 3,
                    "dateFormat": "DD/MM/YYYY",
                    "template": "field/calendar.html",
                    "events": [],
                    "disableOrdering": true
                },
                {
                    "name": "IDCONFRECEBIMENTO",
                    "label": "Recebimento",
                    "isVisible": true,
                    "readOnly": false,
                    "showOnForm": true,
                    "showOnView": false,
                    "showOnList": true,
                    "class": 3,
                    "template": "field/text-edit.html",
                    "events": [],
                    "disableOrdering": true
                }
			  ],
			"actions": [
				{
					"name": "salvar",
					"label": "Salvar",
					"isVisible": true,
					"hideIcon": true,
					"showAsAction": "never",
					"events": [
						{
							"name": "ActionEvent",
							"code": "Inicio_Controller.confirmarRecebimento(args.owner.widget)"
						}
					]
				},
				{
                    "name": "ENTREGATOTAL",
                    "label": "Entrega Total",
                    "isVisible": true,
                    "icon": "truck-checked",
                    "showAsAction": "checked_rows",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "Inicio_Controller.alteraStatusAF(args.owner.widget, args.owner);"
                        }
                    ]
				},
				{
                    "name": "ENTREGAPARCIAL",
                    "label": "Entrega Parcial",
                    "isVisible": true,
                    "icon": "issue",
                    "showAsAction": "checked_rows",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "Inicio_Controller.alteraStatusAF(args.owner.widget, args.owner);"
                        }
                    ]
				},
				{
                    "name": "NAOENTREGUE",
                    "label": "Não Entregue",
                    "isVisible": true,
                    "icon": "stock-error",
                    "showAsAction": "checked_rows",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "Inicio_Controller.alteraStatusAF(args.owner.widget, args.owner);"
                        }
                    ]
				},
				{
				    "name": "DEVOLUCAO",
                    "label": "Devolução",
                    "isVisible": true,
                    "icon": "before",
                    "showAsAction": "checked_rows",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "Inicio_Controller.alteraStatusAF(args.owner.widget, args.owner);"
                        }
                    ]
				},
				{
				    "name": "NOTHING",
                    "label": "",
                    "isVisible": true,
                    "hideIcon ": true,
                    "showAsAction": "back_list",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "Inicio_Controller.doNothing(args.owner);"
                        }
                    ]
				}
			],
			"events": []
		}, templateManager.container);
		widgetConfirmaRecebAF.reload().then(function(){
        	if(widgetConfirmaRecebAF.dataSource.data.length){
        	    ScreenService.openPopup(widgetConfirmaRecebAF);
        	    self.setVisibilityFooterModalPopUp('0', 'hidden');
        		widgetConfirmaRecebAF.activate();
        		ScreenService.showMessage('Para acessar o TecFood atualize o status de todas as AFs pendentes!');
                setLocalVar('OPENMODALAF', 'N');
        		let interval = setInterval(function () {
        		    if($('.zh-new-grid-recebimentoAF').parents('section.popup-container').find('.zh-footer-left').length){
            		    $('.zh-new-grid-recebimentoAF').parents('section.popup-container').find('.zh-footer-left').attr('style', 'visibility:hidden');
            		    clearInterval(interval);
        		    }
        		}, 500);
            }else{
                setLocalVar('OPENMODALAF', 'S');
                self.verifyDashboard();
            }
		});
	};
    
    this.openModalConfirmaRecebimento = function(){
        let params = {
            CDOPERADOR: getLocalVar('CDOPERADOR'),
            NRORG: getLocalVar('NRORG')
        };
        General.callRestEngine('product#/idAutPerfAcesso', 'Row', params).then(function(callback) {
            if(callback.dataset.data.IDAUTPERFACESSO){
                if(getLocalVar('CDFILIAL')){
                    if(!getLocalVar('OPENMODALAF') || getLocalVar('OPENMODALAF') === 'N'){
                        let row = [{
                            "CDFILIAL" : getLocalVar('CDFILIAL')
                        }];
                        General.callRestEngine('product#/verifyParamIdutlconfrecaf', 'Row', row).then(function(callback) {
                            if(callback.dataset && callback.dataset.data && callback.dataset.data.IDUTLCONFRECAF === 'S'){
                                modalConfirmaRecebimentoAF();
                            }else{
                                setLocalVar('OPENMODALAF', 'S');
                                self.verifyDashboard();
                            }
                	    });
                    }else{
                        self.verifyDashboard();
                    }
                }
            }else{
                self.verifyDashboard();
            }
        });
    };
    
    this.confirmarRecebimento = function(widget){
        let rowsUpdate = [];
        
        widget.dataSource.data.filter(function (rowUpdate){
            if(rowUpdate.changed){
                rowsUpdate.push(rowUpdate);
            }
        });
        if(rowsUpdate.length){
            General.callRestEngine('product#/updateStatusAF', 'Row', rowsUpdate).then(function(callback) {
                ScreenService.closePopup(widget);
                self.setVisibilityFooterModalPopUp('0', 'none');
                modalConfirmaRecebimentoAF();
    	    });
        }else{
            ScreenService.showMessage('Para acessar o TecFood atualize o status de todas as AFs pendentes!');
        }
    };
    
    this.alteraStatusAF = function(widget, action){
        let status;
        switch (action.name) {
            case 'ENTREGATOTAL':
                status = 'Entrega Total';
                break;
            case 'ENTREGAPARCIAL':
                status = 'Entrega Parcial';
                break;
            case 'NAOENTREGUE':
                status = 'Não Entregue';
                break;
            default:
                status = 'Devolução';
                break;
        }
        let backupRow;
        let index;
        let data = widget.dataSource.data;
        data.forEach(function (row){
            if(row.__isSelected){
                row.IDCONFRECEBIMENTO = status;
                row.changed = true;
                backupRow = row;
                index = data.indexOf(row);
                delete data[index];
                data.push(backupRow);
            }
        });
        
        widget.dataSource.clearCheckedRows();
        
    };
    
    this.verifyDashboard = function() {
        if(typeof templateManager.project.modulesInfo === "string" && templateManager.project.modulesInfo.split(', ').indexOf('dsb') === -1){
            var filter = [{
                'name': 'P_CDFILIAL',
    			'operator': '=',
    			'value': "FILIAL_LOGADA"
            },{
                'name': 'P_CDOPERADOR',
    			'operator': '=',
    			'value': "OPERADOR_LOGADO"
            }];
            
            requestDataSourceEngine.getDataSource("dsb#/crud/hasAccess", filter).then(function(response){
                if (response.dataset.hasAccess.length && response.dataset.hasAccess[0].NRPAINEL) {
					localStorageEngine.setDataSource("dsb#/painelPadrao", response.dataset.hasAccess).then(function() {
						LibUtilities.openWindow("dsb#dashboard");
					});
				}
            });
        }
    };
    
    this.setVisibilityFooterModalPopUp = function(idModal, visibility) {
        let interval = setInterval(function() {
            if($('#grid-' + idModal).length) {
                clearInterval(interval);
                $('#grid-' + idModal).parents('section.navbar-fixed-bottom').siblings('footer').find('div#footer').attr('style', 'visibility: ' + visibility);
            }            
        }, 500);
    };
    
};


Configuration(function(ContextRegister) {
       ContextRegister.register('Inicio_Controller', Inicio_Controller);
});